package u8c.ui.mm.action;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JSplitPane;
import javax.swing.border.BevelBorder;

import nc.bs.framework.common.NCLocator;
import nc.hr.utils.PubEnv;
import nc.itf.uap.IUAPQueryBS;
import nc.itf.uap.pf.IplatFormEntry;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.ui.pub.ClientEnvironment;
import nc.ui.pub.beans.MessageDialog;
import nc.ui.pub.beans.UIButton;
import nc.ui.pub.beans.UIDialog;
import nc.ui.pub.beans.UIPanel;
import nc.ui.pub.beans.UISplitPane;
import nc.ui.pub.bill.BillCardPanel;
import nc.ui.pub.bill.BillEditEvent;
import nc.ui.pub.bill.BillEditListener;
import nc.vo.OperationTransferVO;
import nc.vo.hr.tools.pub.HRAggVO;
import nc.vo.ic.pub.bill.SpecialBillHeaderVO;
import nc.vo.ic.pub.bill.SpecialBillItemVO;
import nc.vo.ic.pub.bill.SpecialBillVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.CircularlyAccessibleValueObject;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDouble;
import u8c.itf.mm.IOperationInfo;
import u8c.pubitf.ic.out.IMaterialOutMaintainAPI;

@SuppressWarnings("deprecation")
public class ToTranStorDialog extends UIDialog implements ActionListener, BillEditListener {

	private IUAPQueryBS iuap = (IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
	private IplatFormEntry iIplatFormEntry = (IplatFormEntry) NCLocator.getInstance()
			.lookup(IplatFormEntry.class.getName());

	/**
	 * 弹框勾选推单生成下游单据-转库单
	 */
	private static final long serialVersionUID = -2605551888165671265L;
	/** 按钮组 **/
	private UISplitPane mainpanel = null;
	private int focus = 1;
	private UIPanel ivjUIPanel0 = null;
	private UIPanel ivjUIPanel2 = null;
	private BillCardPanel jlcardPanel = null;// 卡面面板
	private UIPanel jlbtnpanel = null;// 存放按钮的panel
	private UIButton saveCardBtn = null; // 保存按钮
	private UIButton cancelBtn = null; // 取消按钮
	private UIButton selectallBtn = null; // 全选按钮
	private UIButton cancelallBtn = null; // 全消按钮
	private ClientEnvironment ce = ClientEnvironment.getInstance();
	private OperationTransferVO[] tranArrays = null;
	private HRAggVO aggvo;
	IMaterialOutMaintainAPI imaterapi = (IMaterialOutMaintainAPI) NCLocator.getInstance()
			.lookup(IMaterialOutMaintainAPI.class.getName());
//	IOperationInfo ioper = NCLocator.getInstance().lookup(IOperationInfo.class);

	public ToTranStorDialog(HRAggVO aggvo) {
		super();
		initialize(aggvo);
	}

	public void initialize(HRAggVO aggvo) {
		Dimension dimension = Toolkit.getDefaultToolkit().getScreenSize();
		setName("clc");
		setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
		setTitle("MRP运算清单-生成转库单");
		setSize(dimension.width - 100, dimension.height - 200);
		this.setResizable(true);
		add(getUIPanel0(), BorderLayout.NORTH);
		add(getUIPanel2(), BorderLayout.CENTER);
		setLocation(100 / 2, 200 / 2);
		addListenerEvent();
		this.aggvo = aggvo;
		// 展示数据
		this.tranArrays = getTranArrays(aggvo);
		getJlcardPanel().getBillModel().setBodyDataVO(tranArrays);
	}

	// 根据传入的aggvo获取tranvo数组
	private OperationTransferVO[] getTranArrays(HRAggVO aggvo) {
		CircularlyAccessibleValueObject[] vos = aggvo.getAllChildrenVO();
		List<OperationTransferVO> tranvos = new ArrayList<OperationTransferVO>();
		for (CircularlyAccessibleValueObject vo : vos) {
			if (vo instanceof OperationTransferVO) {
				// 本次执行数量不填就默认
				// 执行完的表体在生单界面不展示
				OperationTransferVO tranvo = (OperationTransferVO) vo;
				UFDouble num = tranvo.getNum() == null ? UFDouble.ZERO_DBL : tranvo.getNum();
				UFDouble execnum = tranvo.getExecnum() == null ? UFDouble.ZERO_DBL : new UFDouble(tranvo.getExecnum());
				if (num.sub(execnum).compareTo(UFDouble.ZERO_DBL) == 0) {
					continue;
				}
				tranvo.setVdef2(num.sub(execnum).setScale(2, UFDouble.ROUND_HALF_UP).toString());
				tranvos.add(tranvo);
			}
		}
		OperationTransferVO[] tranArrays = tranvos.toArray(new OperationTransferVO[0]);
		return tranArrays;
	}

	private void addListenerEvent() {
		getSaveCardBtn().addActionListener(this);
		getCancelBtn().addActionListener(this);
		getSelectallBtn().addActionListener(this);
		getCancelallBtn().addActionListener(this);
		getJlcardPanel().addEditListener(this);
	}

	private UIPanel getUIPanel2() {
		if (ivjUIPanel2 == null) {
			ivjUIPanel2 = new UIPanel();
			ivjUIPanel2.setLayout(new BorderLayout());
			ivjUIPanel2.setPreferredSize(new Dimension(0, 500));
			ivjUIPanel2.add(getMainPanel(), BorderLayout.CENTER);
		}
		return this.ivjUIPanel2;
	}

	public UISplitPane getMainPanel() {
		if (mainpanel == null) {
			mainpanel = new UISplitPane();
			mainpanel.setOrientation(JSplitPane.VERTICAL_SPLIT);
			mainpanel.setTopComponent(getJlcardPanel());
			mainpanel.setBottomComponent(getJlbtnpanel());
			mainpanel.setDividerLocation(750);// 分割位置
			mainpanel.setOneTouchExpandable(true);
			mainpanel.setDividerSize(8);
		}
		return mainpanel;
	}

	private UIPanel getUIPanel0() {
		if (ivjUIPanel0 == null) {
			try {
				ivjUIPanel0 = new UIPanel();
				ivjUIPanel0.setLayout(new FlowLayout(FlowLayout.LEFT));
				ivjUIPanel0.add(getSelectallBtn());
				ivjUIPanel0.add(getCancelallBtn());
			} catch (Throwable ivjExc) {
				handleException(ivjExc);
			}
		}
		return this.ivjUIPanel0;
	}

	private void handleException(Throwable e) {

	}

	public UIPanel getJlbtnpanel() {
		if (jlbtnpanel == null) {
			jlbtnpanel = new UIPanel();
			jlbtnpanel.setName("jlbtnpanel");
			jlbtnpanel.add(getSaveCardBtn());
			jlbtnpanel.add(getCancelBtn());
		}
		return jlbtnpanel;
	}

	/**
	 * 全选与反选,flag为true时，全选操作，flag为false时，进行反选操作
	 */
	private void onselectall(boolean flag) {
		switch (focus) {
		case 1:
			int jfRowCount = getJlcardPanel().getRowCount();
			if (jfRowCount > 0) {
				for (int row = 0; row < jfRowCount; row++) {
					getJlcardPanel().getBillModel().setValueAt(flag, row, "vdef1");
				}
			}
			break;
		}
	}

	private UIButton getSelectallBtn() {
		if (selectallBtn == null) {
			selectallBtn = new UIButton();
			selectallBtn.setName("selectallBtn");
			selectallBtn.setText("  全选  ");
			Color clrBack = new Color(0XC4C4C4);
			selectallBtn.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED, Color.white, clrBack,
					new Color(0X5F5F5F), clrBack));
		}
		return this.selectallBtn;
	}

	private UIButton getCancelallBtn() {
		if (cancelallBtn == null) {
			cancelallBtn = new UIButton();
			cancelallBtn.setName("cancelallBtn");
			cancelallBtn.setText("  全消  ");
			Color clrBack = new Color(0XC4C4C4);
			cancelallBtn.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED, Color.white, clrBack,
					new Color(0X5F5F5F), clrBack));
		}
		return this.cancelallBtn;
	}

	public UIButton getSaveCardBtn() {
		if (saveCardBtn == null) {
			saveCardBtn = new UIButton();
			saveCardBtn.setBounds(530, 210, 20, 20);
			saveCardBtn.setName("saveCardBtn");
			saveCardBtn.setText("确定");
		}
		return saveCardBtn;
	}

	public UIButton getCancelBtn() {
		if (cancelBtn == null) {
			cancelBtn = new UIButton();
			cancelBtn.setBounds(530, 210, 75, 20);
			cancelBtn.setName("cancelBtn");
			cancelBtn.setText("取消");
		}
		return cancelBtn;
	}

	private BillCardPanel getJlcardPanel() {
		if (jlcardPanel == null) {
			jlcardPanel = new BillCardPanel();
			jlcardPanel.setName("jlcardPanel");
			// 根据单据模板编码加载模板
			jlcardPanel.loadTemplet("MM002", null, ce.getUser().getPrimaryKey(), ce.getCorporation().getPrimaryKey());
		}
		return jlcardPanel;
	}

	@Override
	public void afterEdit(BillEditEvent arg0) {
		// TODO Auto-generated method stub
	}

	@Override
	public void bodyRowChange(BillEditEvent arg0) {
		// TODO Auto-generated method stub
	}

	@SuppressWarnings("unchecked")
	@Override
	/**
	 * 按钮确定和取消执行方法
	 */
	public void actionPerformed(ActionEvent e) {
		// 保存按钮
		if (e.getSource() == getSaveCardBtn()) {
//			MessageDialog.showHintDlg(null, "测试", "开始");
			Vector<Vector<Object>> vectors = getJlcardPanel().getBillModel().getDataVector();
			StringBuffer errmsg = new StringBuffer();
			// 数量校验
			try {
				int execsize = 0;// 勾选的条数
				for (int i = 0; i < vectors.size(); i++) {
					Vector<Object> vector = (Vector<Object>) vectors.get(i);
					if (null != vector.get(0) && "Y".equals(vector.get(0).toString())) {
						if (vector.get(1) == null) {
							errmsg.append("第" + (i + 1) + "行本次执行数量为空！");
							continue;
						}
						execsize = execsize + 1;
						UFDouble execnum = new UFDouble(vector.get(1).toString());// 本次执行数量
						UFDouble nnum = new UFDouble(vector.get(5).toString());// 主数量
						UFDouble usednum = vector.get(39) == null ? new UFDouble(0)
								: new UFDouble(vector.get(39).toString());// 已执行主数量
						if (execnum.compareTo(nnum.sub(usednum)) > 0) {
							errmsg.append("第" + (i + 1) + "行本次执行数量超过订单剩余数量！");
						}
					}
				}

				if (!errmsg.toString().equals("")) {
					MessageDialog.showErrorDlg(mainpanel, "错误", errmsg.toString());
					return;
				}
				if (execsize == 0) {
					MessageDialog.showHintDlg(mainpanel, "提示", "请勾选要生成转库单的数据");
					return;
				}
				SpecialBillVO aggvo = new SpecialBillVO();
				SpecialBillHeaderVO headvo = new SpecialBillHeaderVO();
				// 表头赋值
				headvo.setCbilltypecode("4K");
	//			headvo.setCinwarehouseid("1001V51000000000039Z");// 入库仓库ID 工装
				headvo.setCinwarehouseid(getstordocpk("GZ001"));//仓库必填
				headvo.setCoperatorid(ClientEnvironment.getInstance().getUser().getPrimaryKey());
	//			headvo.setCoutwarehouseid("1001V5100000000003A1");// 出库仓库ID 家装
				headvo.setCoutwarehouseid(getstordocpk("GZ001"));//仓库必填
				headvo.setCshlddiliverdate(new UFDate(ClientEnvironment.getInstance().getBusinessDate().toString()));
				headvo.setDbilldate(new UFDate(ClientEnvironment.getInstance().getBusinessDate().toString()));
				headvo.setFbillflag(2);
				headvo.setIcheckmode(4);
				headvo.setIPrintCount(0);
				headvo.setPk_corp(PubEnv.getCorpCode());
				headvo.setVshldarrivedate(new UFDate(ClientEnvironment.getInstance().getBusinessDate().toString()));
				aggvo.setParentVO(headvo);
				// 表体
				SpecialBillItemVO[] billitems = new SpecialBillItemVO[execsize];
				Map<String, UFDouble> updatemap = new HashMap<>();
				int k = 0;
				for (int j = 0; j < vectors.size(); j++) {
					Vector<Object> vector = (Vector<Object>) vectors.get(j);
					// 自定义项20 为勾选按钮 ：勾选为Y 没有勾选是null
					if (null != vector.get(0) && "Y".equals(vector.get(0).toString())) {
						SpecialBillItemVO billitem = new SpecialBillItemVO();
						String cmaterialcode = vector.get(6).toString();//
						billitem.setCinventoryid(getCmangchid(getCmangid(cmaterialcode)));
						UFDouble num = new UFDouble(vector.get(1).toString());//
						billitem.setDshldtransnum(num);

						billitems[k] = billitem;
						// 回写数量
						UFDouble updatenum = new UFDouble(vector.get(39) == null ? "0" : vector.get(39).toString())
								.add(new UFDouble(vector.get(1) == null ? "0" : vector.get(1).toString()));
						updatemap.put(vector.get(40).toString(), updatenum);
						k = k + 1;
					}
				}

				aggvo.setChildrenVO(billitems);
				iIplatFormEntry.processAction("WRITE", "4K", null, null, aggvo, null, null);
		//		Boolean updateres = ioper.updateTranExecNum(updatemap);
				MessageDialog.showHintDlg(mainpanel, "成功", "转库单新增成功!");
				this.closeCancel();
			} catch (Exception e1) {
				MessageDialog.showErrorDlg(mainpanel, "错误", e1.getMessage());
				return;
			}
		}

		// 取消按钮
		if (e.getSource() == getCancelBtn()) {
			this.closeCancel();
		}

		// 全选
		if (e.getSource() == getSelectallBtn()) {
			onselectall(true);
		}

		// 全消
		if (e.getSource() == getCancelallBtn()) {
			onselectall(false);
		}
	}

	/**
	 * 根据物料code查询主键
	 * 
	 * @param code
	 * @return
	 * @throws BusinessException
	 */
	public String getCmangid(String code) throws BusinessException {
		String cmangid = null;
		String sql = " select pk_invbasdoc from bd_invbasdoc" + " where invcode  ='" + code + "' and dr =0 ";
		cmangid = (String) iuap.executeQuery(sql, new ColumnProcessor());
		if (cmangid == null) {
			throw new BusinessException("U8C物料code不存在:" + code);
		}
		return cmangid;
	}

	/**
	 * 存货管理档案
	 * 
	 * @param code
	 * @return
	 * @throws BusinessException
	 */
	public String getCmangchid(String pk_invbasdoc) throws BusinessException {
		String cmangid = null;
		String sql = " select pk_invmandoc from bd_invmandoc" + " where pk_invbasdoc  ='" + pk_invbasdoc
				+ "' and dr =0 ";
		cmangid = (String) iuap.executeQuery(sql, new ColumnProcessor());
		if (cmangid == null) {
			throw new BusinessException("U8C物料code不存在:" + pk_invbasdoc);
		}
		return cmangid;
	}
	
	  public  String getstordocpk(String storcode)throws Exception{
	    	String sql = "select pk_stordoc from bd_stordoc where storcode = '"+storcode+"'";
	    	String pk_stordoc = (String) iuap.executeQuery(sql, new ColumnProcessor());
	    	if(pk_stordoc == null) {
	    		throw new Exception("仓库"+storcode+"未查到，请检查");
	    	}
	    	return pk_stordoc;
	    }
	
}
