package u8c.ui.mytest.action;

import java.util.ArrayList;
import java.util.List;

import nc.bs.framework.common.NCLocator;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.ui.hr.frame.FrameUI;
import nc.ui.hr.frame.action.AbstractAction;
import nc.ui.hr.frame.impl.MainBillMgrPanel;
import nc.ui.pub.beans.MessageDialog;
import nc.vo.hr.tools.pub.HRAggVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.CircularlyAccessibleValueObject;
import nc.vo.pub.ValidationException;
import u8c.itf.po.IDemandPurchaseRequisition;
import u8c.ui.mytest.panel.DemandMainPanel;
import u8c.ui.mytest.panel.DemandTestUI;
import u8c.vo.DemandBVO;
import u8c.vo.DemandVO;

public class DemandPurchaseRequisitionAction extends AbstractAction {

	private IUAPQueryBS iuap = NCLocator.getInstance().lookup(IUAPQueryBS.class);
	DemandTestUI frameUI = null;
	
	public DemandPurchaseRequisitionAction(FrameUI frameUI1) {
		super(frameUI1);
		this.frameUI = (DemandTestUI) frameUI;
	}

	@Override
	public void execute() throws Exception {
		// 获取材料请购单
		MainBillMgrPanel mainMgrPanel = (MainBillMgrPanel) getMainPanel();
		int selectedRow = ((DemandMainPanel) getMainPanel()).getSelectedRow();
		HRAggVO s = (HRAggVO) mainMgrPanel.getMainBillCardPanel().getData();
		DemandVO demandVO = (DemandVO) s.getParentVO();//
		if (1!=demandVO.getBillstatus()) {
			throw new ValidationException("单据需要先审批");// 新增请购单
		}
		//业务类型家装的允许生单，工装的不允许生单 vdef30
		if ("工装".equals(demandVO.getVdef30())) {
			throw new ValidationException("业务类型家装的允许生单，工装的不允许生单");
		}
		
		//校验不允许重复生成请购单
		String sql="select cpraybill_bid from  po_praybill_b where csourcebillid='"+demandVO.getPk_demand()+"' and dr=0; ";
		
		Object pkbid=iuap.executeQuery(sql, new ColumnProcessor());
		
		if(null!=pkbid &&  !"".equals(pkbid)) {
			throw new ValidationException("已经生成请购单，不允许重复生单！");
		}
		
		if (null != s && s != null) {
			CircularlyAccessibleValueObject[] demandBVOList =  s.getAllChildrenVO();//
			List<DemandBVO> demandBVOs = new ArrayList();
			for(CircularlyAccessibleValueObject vo : demandBVOList) {
				if(vo instanceof DemandBVO) {
					demandBVOs.add((DemandBVO)vo);
				}
			}
			if(demandBVOs.size()==0) {
				throw new BusinessException("当前材料采购单没有数据，请先添加数据");
			}
			IDemandPurchaseRequisition iDemandPurchaseRequisition = NCLocator.getInstance().lookup(IDemandPurchaseRequisition.class);
			iDemandPurchaseRequisition.addPraybillVO(demandVO,demandBVOs);
			MessageDialog.showHintDlg(frameUI, "成功", "请购单新增成功");
		}
	}
	
}
